--- old/usr/src/uts/i86pc/io/pcplusmp/apic_regops.c	2014-04-23 20:47:24.727116238 -0400
+++ new/usr/src/uts/i86pc/io/pcplusmp/apic_regops.c	2014-04-23 20:47:24.732904421 -0400
@@ -22,6 +22,9 @@
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  */
+/*
+ * Copyright 2014 Josef 'Jeff' Sipek <jeffpc@josefsipek.net>
+ */
 
 #include <sys/cpuvar.h>
 #include <sys/psm.h>
@@ -94,7 +97,6 @@
 void apic_send_EOI();
 void apic_send_directed_EOI(uint32_t irq);
 
-#define	X2APIC_CPUID_BIT	21
 #define	X2APIC_ENABLE_BIT	10
 
 /*
@@ -233,15 +235,10 @@
 int
 apic_detect_x2apic(void)
 {
-	struct cpuid_regs cp;
-
 	if (x2apic_enable == 0)
 		return (0);
 
-	cp.cp_eax = 1;
-	(void) __cpuid_insn(&cp);
-
-	return ((cp.cp_ecx & (0x1 << X2APIC_CPUID_BIT)) ? 1 : 0);
+	return (is_x86_feature(x86_featureset, X86FSET_X2APIC));
 }
 
 void
